using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Net;

using DirkRettschlag.Utils;

namespace Departure
{
    public partial class frmSettings : Form
    {

        HttpWebRequest request;

        private string _Transfers1;
        private string _Transfers1Registry = "000000000000";
        private string _Transfers2;
        private string _Transfers2Registry = "000000000000";
        private string _Transfers3;
        private string _Transfers3Registry = "000000000000";
        private string _Transfers4;
        private string _Transfers4Registry = "000000000000";

        public string Station1
        {
            get { return Invoking.GetText(txtStation1); }
        }

        public string Station2
        {
            get { return Invoking.GetText(txtStation2); }
        }

        public string Station3
        {
            get { return Invoking.GetText(txtStation3); }
        }

        public string Station4
        {
            get { return Invoking.GetText(txtStation4); }
        }

        public string Transfers1
        {
            get { return _Transfers1; }
        }

        public string Transfers2
        {
            get { return _Transfers2; }
        }

        public string Transfers3
        {
            get { return _Transfers3; }
        }

        public string Transfers4
        {
            get { return _Transfers4; }
        }

        public string TransfersChecked1
        {
            get { return _Transfers1Registry; }
        }

        public string TransfersChecked2
        {
            get { return _Transfers2Registry; }
        }

        public string TransfersChecked3
        {
            get { return _Transfers3Registry; }
        }

        public string TransfersChecked4
        {
            get { return _Transfers4Registry; }
        }

        public string Abbreviation1
        {
            get { return Invoking.GetText(txtAbbreviation1); }
        }

        public string Abbreviation2
        {
            get { return Invoking.GetText(txtAbbreviation2); }
        }

        public string Abbreviation3
        {
            get { return Invoking.GetText(txtAbbreviation3); }
        }

        public string Abbreviation4
        {
            get { return Invoking.GetText(txtAbbreviation4); }
        }

        public bool useTrainsFilter1
        {
            get { return Invoking.GetChecked(chkTrainsFilter1); }
        }

        public bool useTrainsFilter2
        {
            get { return Invoking.GetChecked(chkTrainsFilter2); }
        }

        public bool useTrainsFilter3
        {
            get { return Invoking.GetChecked(chkTrainsFilter3); }
        }

        public bool useTrainsFilter4
        {
            get { return Invoking.GetChecked(chkTrainsFilter4); }
        }

        public string TrainsFilter1
        {
            get { return Invoking.GetText(txtTrainsFilter1); }
        }

        public string TrainsFilter2
        {
            get { return Invoking.GetText(txtTrainsFilter2); }
        }

        public string TrainsFilter3
        {
            get { return Invoking.GetText(txtTrainsFilter3); }
        }

        public string TrainsFilter4
        {
            get { return Invoking.GetText(txtTrainsFilter4); }
        }

        public bool useDirectionsFilter1
        {
            get { return Invoking.GetChecked(chkDirectionsFilter1); }
        }

        public bool useDirectionsFilter2
        {
            get { return Invoking.GetChecked(chkDirectionsFilter2); }
        }

        public bool useDirectionsFilter3
        {
            get { return Invoking.GetChecked(chkDirectionsFilter3); }
        }

        public bool useDirectionsFilter4
        {
            get { return Invoking.GetChecked(chkDirectionsFilter4); }
        }

        public string DirectionsFilter1
        {
            get { return Invoking.GetText(txtDirectionsFilter1); }
        }

        public string DirectionsFilter2
        {
            get { return Invoking.GetText(txtDirectionsFilter2); }
        }

        public string DirectionsFilter3
        {
            get { return Invoking.GetText(txtDirectionsFilter3); }
        }

        public string DirectionsFilter4
        {
            get { return Invoking.GetText(txtDirectionsFilter4); }
        }

        public bool usePlatformsFilter1
        {
            get { return Invoking.GetChecked(chkPlatformsFilter1); }
        }

        public bool usePlatformsFilter2
        {
            get { return Invoking.GetChecked(chkPlatformsFilter2); }
        }

        public bool usePlatformsFilter3
        {
            get { return Invoking.GetChecked(chkPlatformsFilter3); }
        }

        public bool usePlatformsFilter4
        {
            get { return Invoking.GetChecked(chkPlatformsFilter4); }
        }

        public string PlatformsFilter1
        {
            get { return Invoking.GetText(txtPlatformsFilter1); }
        }

        public string PlatformsFilter2
        {
            get { return Invoking.GetText(txtPlatformsFilter2); }
        }

        public string PlatformsFilter3
        {
            get { return Invoking.GetText(txtPlatformsFilter3); }
        }

        public string PlatformsFilter4
        {
            get { return Invoking.GetText(txtPlatformsFilter4); }
        }

        public int UpdateStations
        {
            get 
            {
                if (Invoking.GetText(numericUpDownUpdateStations) == "")
                    return 10;
                else
                    return int.Parse(Invoking.GetText(numericUpDownUpdateStations)); 
            }
        }

        public bool useAutoUpdate
        {
            get { return Invoking.GetChecked(chkAutoUpdate); }
        }

        public bool useWAP
        {
            get { return Invoking.GetChecked(chkWAP); }
        }

        public bool useAutoConnect
        {
            get { return Invoking.GetChecked(chkAutoConnect); }
        }

        public string HTTPHeader
        {
            get { return Invoking.GetText(textBoxHttpHeader); }
        }

        public string UserAgent
        {
            get { return Invoking.GetText(textBoxHttpHeader); }
        }

        public bool useRemovePastDepartures
        {
            get { return Invoking.GetChecked(chkRemovePastDepartures); }
        }

        public string CountdownTrainFormat
        {
            get { return Invoking.GetText(textBoxCountdownTrainFormat); }
        }

        public bool useAndFilter1
        {
            get { return Invoking.GetRadioButtonChecked(rbtFilterLogicStation1AND); }
        }

        public bool useAndFilter2
        {
            get { return Invoking.GetRadioButtonChecked(rbtFilterLogicStation2AND); }
        }

        public bool useAndFilter3
        {
            get { return Invoking.GetRadioButtonChecked(rbtFilterLogicStation3AND); }
        }

        public bool useAndFilter4
        {
            get { return Invoking.GetRadioButtonChecked(rbtFilterLogicStation4AND); }
        }


        public frmSettings()
        {
            InitializeComponent();

            this.tbcSettingsMain.Top = 0;
            this.tbcSettingsMain.Left = 0;
            this.tbcSettingsMain.Height = this.ClientSize.Height;
            this.tbcSettingsMain.Width = this.ClientSize.Width;

            this.labelCountdownTrainFormatDesc.Text = "Description:\r\n\r\n%TI%\t- Time\r\n%TR%\t- Train\r\n%DI%\t- Direction\r\n%PL%\t- Platform";

            getSettings();

        }

        private string AppPath()
        {
            return System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
        }

        private void saveSettings()
        {
            Settings settings = new Settings(AppPath() + "\\settings.xml");

            settings.WriteBool("Main", "AutoUpdate", chkAutoUpdate.Checked);
            settings.WriteString("Main", "UpdateInterval", numericUpDownUpdateStations.Value.ToString());
            settings.WriteBool("Main", "useWAP", chkWAP.Checked);
            settings.WriteBool("Main", "AutoConnect", chkAutoConnect.Checked);
            settings.WriteString("Main", "HTTPHeader", textBoxHttpHeader.Text);
            settings.WriteString("Main", "UserAgent", textBoxUserAgent.Text);
            settings.WriteBool("Main", "RemovePastDepartures", chkRemovePastDepartures.Checked);
            settings.WriteString("Main", "CountdownTrainFormat", textBoxCountdownTrainFormat.Text);

            //------------------------------------------------------------------------------------------

            settings.WriteString("Station1", "Station", txtStation1.Text);
            settings.WriteString("Station1", "Abbreviation", txtAbbreviation1.Text);
            settings.WriteString("Station1", "Transfers", _Transfers1Registry);
            settings.WriteBool("Station1", "useTrainsFilter", chkTrainsFilter1.Checked);
            settings.WriteString("Station1", "TrainsFilter", txtTrainsFilter1.Text);
            settings.WriteBool("Station1", "useDirectionsFilter", chkDirectionsFilter1.Checked);
            settings.WriteString("Station1", "DirectionsFilter", txtDirectionsFilter1.Text);
            settings.WriteBool("Station1", "usePlatformsFilter", chkPlatformsFilter1.Checked);
            settings.WriteString("Station1", "PlatformsFilter", txtPlatformsFilter1.Text);
            settings.WriteBool("Station1", "useAndFilter", rbtFilterLogicStation1AND.Checked);

            //------------------------------------------------------------------------------------------

            settings.WriteString("Station2", "Station", txtStation2.Text);
            settings.WriteString("Station2", "Abbreviation", txtAbbreviation2.Text);
            settings.WriteString("Station2", "Transfers", _Transfers2Registry);
            settings.WriteBool("Station2", "useTrainsFilter", chkTrainsFilter2.Checked);
            settings.WriteString("Station2", "TrainsFilter", txtTrainsFilter2.Text);
            settings.WriteBool("Station2", "useDirectionsFilter", chkDirectionsFilter2.Checked);
            settings.WriteString("Station2", "DirectionsFilter", txtDirectionsFilter2.Text);
            settings.WriteBool("Station2", "usePlatformsFilter", chkPlatformsFilter2.Checked);
            settings.WriteString("Station2", "PlatformsFilter", txtPlatformsFilter2.Text);
            settings.WriteBool("Station2", "useAndFilter", rbtFilterLogicStation2AND.Checked);

            //------------------------------------------------------------------------------------------

            settings.WriteString("Station3", "Station", txtStation3.Text);
            settings.WriteString("Station3", "Abbreviation", txtAbbreviation3.Text);
            settings.WriteString("Station3", "Transfers", _Transfers3Registry);
            settings.WriteBool("Station3", "useTrainsFilter", chkTrainsFilter3.Checked);
            settings.WriteString("Station3", "TrainsFilter", txtTrainsFilter3.Text);
            settings.WriteBool("Station3", "useDirectionsFilter", chkDirectionsFilter3.Checked);
            settings.WriteString("Station3", "DirectionsFilter", txtDirectionsFilter3.Text);
            settings.WriteBool("Station3", "usePlatformsFilter", chkPlatformsFilter3.Checked);
            settings.WriteString("Station3", "PlatformsFilter", txtPlatformsFilter3.Text);
            settings.WriteBool("Station3", "useAndFilter", rbtFilterLogicStation3AND.Checked);

            //------------------------------------------------------------------------------------------

            settings.WriteString("Station4", "Station", txtStation4.Text);
            settings.WriteString("Station4", "Abbreviation", txtAbbreviation4.Text);
            settings.WriteString("Station4", "Transfers", _Transfers4Registry);
            settings.WriteBool("Station4", "useTrainsFilter", chkTrainsFilter4.Checked);
            settings.WriteString("Station4", "TrainsFilter", txtTrainsFilter4.Text);
            settings.WriteBool("Station4", "useDirectionsFilter", chkDirectionsFilter4.Checked);
            settings.WriteString("Station4", "DirectionsFilter", txtDirectionsFilter4.Text);
            settings.WriteBool("Station4", "usePlatformsFilter", chkPlatformsFilter4.Checked);
            settings.WriteString("Station4", "PlatformsFilter", txtPlatformsFilter4.Text);
            settings.WriteBool("Station4", "useAndFilter", rbtFilterLogicStation4AND.Checked);

            //------------------------------------------------------------------------------------------

            settings.Save();

        }


        private void getSettings()
        {

            string tmpTransfers;

            Settings settings = new Settings(AppPath() + "\\settings.xml");

            chkAutoUpdate.Checked = settings.ReadBool("Main", "AutoUpdate", false);
            numericUpDownUpdateStations.Value = decimal.Parse(settings.ReadString("Main", "UpdateInterval", "10"));
            chkWAP.Checked = settings.ReadBool("Main", "useWAP", false);
            chkAutoConnect.Checked = settings.ReadBool("Main", "AutoConnect", false);
            textBoxHttpHeader.Text = settings.ReadString("Main", "HTTPHeader", "");
            textBoxUserAgent.Text = settings.ReadString("Main", "UserAgent", "");
            chkRemovePastDepartures.Checked = settings.ReadBool("Main", "RemovePastDepartures", false);
            textBoxCountdownTrainFormat.Text = settings.ReadString("Main", "CountdownTrainFormat", "%TR% - %DI%");

            //------------------------------------------------------------------------------------------

            txtStation1.Text = settings.ReadString("Station1", "Station", "");
            txtAbbreviation1.Text = settings.ReadString("Station1", "Abbreviation", "");
            tmpTransfers = settings.ReadString("Station1", "Transfers", "000000000000");

            if (tmpTransfers[0].ToString() == "1") { chkICE1.Checked = true; } else { chkICE1.Checked = false; }
            if (tmpTransfers[1].ToString() == "1") { chkECIC1.Checked = true; } else { chkECIC1.Checked = false; }
            if (tmpTransfers[2].ToString() == "1") { chkIR1.Checked = true; } else { chkIR1.Checked = false; }
            if (tmpTransfers[3].ToString() == "1") { chkIRE1.Checked = true; } else { chkIRE1.Checked = false; }
            if (tmpTransfers[4].ToString() == "1") { chkRE1.Checked = true; } else { chkRE1.Checked = false; }
            if (tmpTransfers[5].ToString() == "1") { chkRB1.Checked = true; } else { chkRB1.Checked = false; }
            if (tmpTransfers[6].ToString() == "1") { chkSBahn1.Checked = true; } else { chkSBahn1.Checked = false; }
            if (tmpTransfers[7].ToString() == "1") { chkBus1.Checked = true; } else { chkBus1.Checked = false; }
            if (tmpTransfers[8].ToString() == "1") { chkBoat1.Checked = true; } else { chkBoat1.Checked = false; }
            if (tmpTransfers[9].ToString() == "1") { chkUBahn1.Checked = true; } else { chkUBahn1.Checked = false; }
            if (tmpTransfers[10].ToString() == "1") { chkTram1.Checked = true; } else { chkTram1.Checked = false; }
            if (tmpTransfers[11].ToString() == "1") { chkTaxi1.Checked = true; } else { chkTaxi1.Checked = false; }

            chkTrainsFilter1.Checked = settings.ReadBool("Station1", "useTrainsFilter", false);
            txtTrainsFilter1.Text = settings.ReadString("Station1", "TrainsFilter", "");

            chkDirectionsFilter1.Checked = settings.ReadBool("Station1", "useDirectionsFilter", false);
            txtDirectionsFilter1.Text = settings.ReadString("Station1", "DirectionsFilter", "");

            chkPlatformsFilter1.Checked = settings.ReadBool("Station1", "usePlatformsFilter", false);
            txtPlatformsFilter1.Text = settings.ReadString("Station1", "PlatformsFilter", "");

            rbtFilterLogicStation1AND.Checked = settings.ReadBool("Station1", "useAndFilter", false);
            rbtFilterLogicStation1OR.Checked = !rbtFilterLogicStation1AND.Checked;

            //------------------------------------------------------------------------------------------

            txtStation2.Text = settings.ReadString("Station2", "Station", "");
            txtAbbreviation2.Text = settings.ReadString("Station2", "Abbreviation", "");
            tmpTransfers = settings.ReadString("Station2", "Transfers", "000000000000");

            if (tmpTransfers[0].ToString() == "1") { chkICE2.Checked = true; } else { chkICE2.Checked = false; }
            if (tmpTransfers[1].ToString() == "1") { chkECIC2.Checked = true; } else { chkECIC2.Checked = false; }
            if (tmpTransfers[2].ToString() == "1") { chkIR2.Checked = true; } else { chkIR2.Checked = false; }
            if (tmpTransfers[3].ToString() == "1") { chkIRE2.Checked = true; } else { chkIRE2.Checked = false; }
            if (tmpTransfers[4].ToString() == "1") { chkRE2.Checked = true; } else { chkRE2.Checked = false; }
            if (tmpTransfers[5].ToString() == "1") { chkRB2.Checked = true; } else { chkRB2.Checked = false; }
            if (tmpTransfers[6].ToString() == "1") { chkSBahn2.Checked = true; } else { chkSBahn2.Checked = false; }
            if (tmpTransfers[7].ToString() == "1") { chkBus2.Checked = true; } else { chkBus2.Checked = false; }
            if (tmpTransfers[8].ToString() == "1") { chkBoat2.Checked = true; } else { chkBoat2.Checked = false; }
            if (tmpTransfers[9].ToString() == "1") { chkUBahn2.Checked = true; } else { chkUBahn2.Checked = false; }
            if (tmpTransfers[10].ToString() == "1") { chkTram2.Checked = true; } else { chkTram2.Checked = false; }
            if (tmpTransfers[11].ToString() == "1") { chkTaxi2.Checked = true; } else { chkTaxi2.Checked = false; }

            chkTrainsFilter2.Checked = settings.ReadBool("Station2", "useTrainsFilter", false);
            txtTrainsFilter2.Text = settings.ReadString("Station2", "TrainsFilter", "");

            chkDirectionsFilter2.Checked = settings.ReadBool("Station2", "useDirectionsFilter", false);
            txtDirectionsFilter2.Text = settings.ReadString("Station2", "DirectionsFilter", "");

            chkPlatformsFilter2.Checked = settings.ReadBool("Station2", "usePlatformsFilter", false);
            txtPlatformsFilter2.Text = settings.ReadString("Station2", "PlatformsFilter", "");

            rbtFilterLogicStation2AND.Checked = settings.ReadBool("Station2", "useAndFilter", false);
            rbtFilterLogicStation2OR.Checked = !rbtFilterLogicStation2AND.Checked;

            //------------------------------------------------------------------------------------------

            txtStation3.Text = settings.ReadString("Station3", "Station", "");
            txtAbbreviation3.Text = settings.ReadString("Station3", "Abbreviation", "");
            tmpTransfers = settings.ReadString("Station3", "Transfers", "000000000000");

            if (tmpTransfers[0].ToString() == "1") { chkICE3.Checked = true; } else { chkICE3.Checked = false; }
            if (tmpTransfers[1].ToString() == "1") { chkECIC3.Checked = true; } else { chkECIC3.Checked = false; }
            if (tmpTransfers[2].ToString() == "1") { chkIR3.Checked = true; } else { chkIR3.Checked = false; }
            if (tmpTransfers[3].ToString() == "1") { chkIRE3.Checked = true; } else { chkIRE3.Checked = false; }
            if (tmpTransfers[4].ToString() == "1") { chkRE3.Checked = true; } else { chkRE3.Checked = false; }
            if (tmpTransfers[5].ToString() == "1") { chkRB3.Checked = true; } else { chkRB3.Checked = false; }
            if (tmpTransfers[6].ToString() == "1") { chkSBahn3.Checked = true; } else { chkSBahn3.Checked = false; }
            if (tmpTransfers[7].ToString() == "1") { chkBus3.Checked = true; } else { chkBus3.Checked = false; }
            if (tmpTransfers[8].ToString() == "1") { chkBoat3.Checked = true; } else { chkBoat3.Checked = false; }
            if (tmpTransfers[9].ToString() == "1") { chkUBahn3.Checked = true; } else { chkUBahn3.Checked = false; }
            if (tmpTransfers[10].ToString() == "1") { chkTram3.Checked = true; } else { chkTram3.Checked = false; }
            if (tmpTransfers[11].ToString() == "1") { chkTaxi3.Checked = true; } else { chkTaxi3.Checked = false; }

            chkTrainsFilter3.Checked = settings.ReadBool("Station3", "useTrainsFilter", false);
            txtTrainsFilter3.Text = settings.ReadString("Station3", "TrainsFilter", "");

            chkDirectionsFilter3.Checked = settings.ReadBool("Station3", "useDirectionsFilter", false);
            txtDirectionsFilter3.Text = settings.ReadString("Station3", "DirectionsFilter", "");

            chkPlatformsFilter3.Checked = settings.ReadBool("Station3", "usePlatformsFilter", false);
            txtPlatformsFilter3.Text = settings.ReadString("Station3", "PlatformsFilter", "");

            rbtFilterLogicStation3AND.Checked = settings.ReadBool("Station3", "useAndFilter", false);
            rbtFilterLogicStation3OR.Checked = !rbtFilterLogicStation3AND.Checked;

            //------------------------------------------------------------------------------------------

            txtStation4.Text = settings.ReadString("Station4", "Station", "");
            txtAbbreviation4.Text = settings.ReadString("Station4", "Abbreviation", "");
            tmpTransfers = settings.ReadString("Station4", "Transfers", "000000000000");

            if (tmpTransfers[0].ToString() == "1") { chkICE4.Checked = true; } else { chkICE4.Checked = false; }
            if (tmpTransfers[1].ToString() == "1") { chkECIC4.Checked = true; } else { chkECIC4.Checked = false; }
            if (tmpTransfers[2].ToString() == "1") { chkIR4.Checked = true; } else { chkIR4.Checked = false; }
            if (tmpTransfers[3].ToString() == "1") { chkIRE4.Checked = true; } else { chkIRE4.Checked = false; }
            if (tmpTransfers[4].ToString() == "1") { chkRE4.Checked = true; } else { chkRE4.Checked = false; }
            if (tmpTransfers[5].ToString() == "1") { chkRB4.Checked = true; } else { chkRB4.Checked = false; }
            if (tmpTransfers[6].ToString() == "1") { chkSBahn4.Checked = true; } else { chkSBahn4.Checked = false; }
            if (tmpTransfers[7].ToString() == "1") { chkBus4.Checked = true; } else { chkBus4.Checked = false; }
            if (tmpTransfers[8].ToString() == "1") { chkBoat4.Checked = true; } else { chkBoat4.Checked = false; }
            if (tmpTransfers[9].ToString() == "1") { chkUBahn4.Checked = true; } else { chkUBahn4.Checked = false; }
            if (tmpTransfers[10].ToString() == "1") { chkTram4.Checked = true; } else { chkTram4.Checked = false; }
            if (tmpTransfers[11].ToString() == "1") { chkTaxi4.Checked = true; } else { chkTaxi4.Checked = false; }

            chkTrainsFilter4.Checked = settings.ReadBool("Station4", "useTrainsFilter", false);
            txtTrainsFilter4.Text = settings.ReadString("Station4", "TrainsFilter", "");

            chkDirectionsFilter4.Checked = settings.ReadBool("Station4", "useDirectionsFilter", false);
            txtDirectionsFilter4.Text = settings.ReadString("Station4", "DirectionsFilter", "");

            chkPlatformsFilter4.Checked = settings.ReadBool("Station4", "usePlatformsFilter", false);
            txtPlatformsFilter4.Text = settings.ReadString("Station4", "PlatformsFilter", "");

            rbtFilterLogicStation4AND.Checked = settings.ReadBool("Station4", "useAndFilter", false);
            rbtFilterLogicStation4OR.Checked = !rbtFilterLogicStation4AND.Checked;
        }

        private void mniSave_Click(object sender, EventArgs e)
        {
            saveSettings();
            cboChoose1.Visible = false;
            lblChoose1.Text = "";

            cboChoose2.Visible = false;
            lblChoose2.Text = "";

            cboChoose3.Visible = false;
            lblChoose3.Text = "";

            cboChoose4.Visible = false;
            lblChoose4.Text = "";

            this.Close();
        }

        private void mniCancel_Click(object sender, EventArgs e)
        {
            getSettings();
            cboChoose1.Visible = false;
            lblChoose1.Text = "";

            cboChoose2.Visible = false;
            lblChoose2.Text = "";

            cboChoose3.Visible = false;
            lblChoose3.Text = "";

            cboChoose4.Visible = false;
            lblChoose4.Text = "";

            this.Close();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {

            try
            {

                if (Connected() || useAutoConnect)
                {

                    Cursor.Current = Cursors.WaitCursor;

                    switch (tbcSettingsMain.SelectedIndex)
                    {
                        case 0:
                            lblChoose1.Text = "Searching...";
                            lblChoose1.Refresh();
                            cboChoose1.Items.Clear();
                            break;
                        case 1:
                            lblChoose2.Text = "Searching...";
                            lblChoose2.Refresh();
                            cboChoose2.Items.Clear();
                            break;
                        case 2:
                            lblChoose3.Text = "Searching...";
                            lblChoose3.Refresh();
                            cboChoose3.Items.Clear();
                            break;
                        case 3:
                            lblChoose4.Text = "Searching...";
                            lblChoose4.Refresh();
                            cboChoose4.Items.Clear();
                            break;
                    }

                    Application.DoEvents();

                    switch (tbcSettingsMain.SelectedIndex)
                    {
                        case 0:
                            request = (HttpWebRequest)WebRequest.Create("http://reiseauskunft.bahn.de/bin/bhftafel.exe/en?L=ua_pda&input=" + txtStation1.Text + "&time=actual&boardType=dep&productsFilter=0000001000000000&start=Anzeigen&distance=1");
                            break;
                        case 1:
                            request = (HttpWebRequest)WebRequest.Create("http://reiseauskunft.bahn.de/bin/bhftafel.exe/en?L=ua_pda&input=" + txtStation2.Text + "&time=actual&boardType=dep&productsFilter=0000001000000000&start=Anzeigen&distance=1");
                            break;
                        case 2:
                            request = (HttpWebRequest)WebRequest.Create("http://reiseauskunft.bahn.de/bin/bhftafel.exe/en?L=ua_pda&input=" + txtStation3.Text + "&time=actual&boardType=dep&productsFilter=0000001000000000&start=Anzeigen&distance=1");
                            break;
                        case 3:
                            request = (HttpWebRequest)WebRequest.Create("http://reiseauskunft.bahn.de/bin/bhftafel.exe/en?L=ua_pda&input=" + txtStation4.Text + "&time=actual&boardType=dep&productsFilter=0000001000000000&start=Anzeigen&distance=1");
                            break;
                    }

                    request.Credentials = CredentialCache.DefaultCredentials;
                    request.KeepAlive = true;
                    request.Method = "GET";

                    if (UserAgent != "")
                        request.UserAgent = UserAgent;

                    if (HTTPHeader != "")
                        request.Headers.Add(HTTPHeader);

                    HttpWebResponse response = (HttpWebResponse)request.GetResponse();

                    System.IO.StreamReader sr = new System.IO.StreamReader(response.GetResponseStream());

                    string source = sr.ReadToEnd();

                    sr.Close();

                    if (source.IndexOf("Your input is ambiguous.") >= 0)
                    {
                        Regex regex = new Regex("<select name=\"input\".*?</select>", RegexOptions.Singleline | RegexOptions.IgnoreCase);
                        Match match;
                        MatchCollection matchcollection;

                        match = regex.Match(source);

                        if (match.Success)
                        {

                            regex = new Regex("<option.*?>.*?</option>", RegexOptions.IgnoreCase);

                            matchcollection = regex.Matches(match.Value);

                            switch (tbcSettingsMain.SelectedIndex)
                            {
                                case 0:
                                    foreach (Match tmpmatch in matchcollection)
                                    {
                                        cboChoose1.Items.Add(ClearText(Regex.Replace(tmpmatch.Value, "<.*?>", "")));
                                    }

                                    lblChoose1.Text = "Multiple Stations found:";

                                    cboChoose1.SelectedIndex = 0;
                                    cboChoose1.Visible = true;
                                    break;
                                case 1:
                                    foreach (Match tmpmatch in matchcollection)
                                    {
                                        cboChoose2.Items.Add(ClearText(Regex.Replace(tmpmatch.Value, "<.*?>", "")));
                                    }

                                    lblChoose2.Text = "Multiple Stations found:";

                                    cboChoose2.SelectedIndex = 0;
                                    cboChoose2.Visible = true;
                                    break;
                                case 2:
                                    foreach (Match tmpmatch in matchcollection)
                                    {
                                        cboChoose3.Items.Add(ClearText(Regex.Replace(tmpmatch.Value, "<.*?>", "")));
                                    }

                                    lblChoose3.Text = "Multiple Stations found:";

                                    cboChoose3.SelectedIndex = 0;
                                    cboChoose3.Visible = true;
                                    break;
                                case 3:
                                    foreach (Match tmpmatch in matchcollection)
                                    {
                                        cboChoose4.Items.Add(ClearText(Regex.Replace(tmpmatch.Value, "<.*?>", "")));
                                    }

                                    lblChoose4.Text = "Multiple Stations found:";

                                    cboChoose4.SelectedIndex = 0;
                                    cboChoose4.Visible = true;
                                    break;
                            }

                        }
                        else
                        {
                            switch (tbcSettingsMain.SelectedIndex)
                            {
                                case 0:
                                    lblChoose1.Text = "Error.";
                                    break;
                                case 1:
                                    lblChoose2.Text = "Error.";
                                    break;
                                case 2:
                                    lblChoose3.Text = "Error.";
                                    break;
                                case 3:
                                    lblChoose4.Text = "Error.";
                                    break;
                            }
                        }

                    }
                    else
                    {
                        switch (tbcSettingsMain.SelectedIndex)
                        {
                            case 0:
                                lblChoose1.Text = "Station found.";
                                break;
                            case 1:
                                lblChoose2.Text = "Station found.";
                                break;
                            case 2:
                                lblChoose3.Text = "Station found.";
                                break;
                            case 3:
                                lblChoose4.Text = "Station found.";
                                break;
                        }
                    }

                    Cursor.Current = Cursors.Default;
                }

            }
            catch (Exception ex)
            {
                Cursor.Current = Cursors.Default;

                MessageBox.Show(ex.Message,"An error occured");

            }

        

        }

        private void cboChoose_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (tbcSettingsMain.SelectedIndex)
            {
                case 0:
                    txtStation1.Text = cboChoose1.SelectedItem.ToString();
                    break;
                case 1:
                    txtStation2.Text = cboChoose2.SelectedItem.ToString();
                    break;
                case 2:
                    txtStation3.Text = cboChoose3.SelectedItem.ToString();
                    break;
                case 3:
                    txtStation4.Text = cboChoose4.SelectedItem.ToString();
                    break;
            }
            
        }

        private void CheckStateChanged(object sender, EventArgs e)
        {
                _Transfers1 = "";

                if (chkICE1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkECIC1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkIR1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkIRE1.Checked || chkRE1.Checked || chkRB1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkSBahn1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkBus1.Checked) _Transfers1 += 1; else _Transfers1 += 1; // always use Bus
                if (chkBoat1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkUBahn1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkTram1.Checked) _Transfers1 += 1; else _Transfers1 += 0;
                if (chkTaxi1.Checked) _Transfers1 += 1; else _Transfers1 += 0;

                _Transfers1 += "000000";

                _Transfers1Registry = "";

                if (chkICE1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkECIC1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkIR1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkIRE1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkRE1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkRB1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkSBahn1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkBus1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkBoat1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkUBahn1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkTram1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;
                if (chkTaxi1.Checked) _Transfers1Registry += 1; else _Transfers1Registry += 0;

                _Transfers2 = "";

                if (chkICE2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkECIC2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkIR2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkIRE2.Checked || chkRE2.Checked || chkRB2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkSBahn2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkBus2.Checked) _Transfers2 += 1; else _Transfers2 += 1; // always use Bus
                if (chkBoat2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkUBahn2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkTram2.Checked) _Transfers2 += 1; else _Transfers2 += 0;
                if (chkTaxi2.Checked) _Transfers2 += 1; else _Transfers2 += 0;

                _Transfers2 += "000000";

                _Transfers2Registry = "";

                if (chkICE2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkECIC2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkIR2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkIRE2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkRE2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkRB2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkSBahn2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkBus2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkBoat2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkUBahn2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkTram2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;
                if (chkTaxi2.Checked) _Transfers2Registry += 1; else _Transfers2Registry += 0;


                _Transfers3 = "";

                if (chkICE3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkECIC3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkIR3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkIRE3.Checked || chkRE3.Checked || chkRB3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkSBahn3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkBus3.Checked) _Transfers3 += 1; else _Transfers3 += 1; // always use Bus
                if (chkBoat3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkUBahn3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkTram3.Checked) _Transfers3 += 1; else _Transfers3 += 0;
                if (chkTaxi3.Checked) _Transfers3 += 1; else _Transfers3 += 0;

                _Transfers3 += "000000";

                _Transfers3Registry = "";

                if (chkICE3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkECIC3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkIR3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkIRE3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkRE3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkRB3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkSBahn3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkBus3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkBoat3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkUBahn3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkTram3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;
                if (chkTaxi3.Checked) _Transfers3Registry += 1; else _Transfers3Registry += 0;

                _Transfers4 = "";

                if (chkICE4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkECIC4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkIR4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkIRE4.Checked || chkRE4.Checked || chkRB4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkSBahn4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkBus4.Checked) _Transfers4 += 1; else _Transfers4 += 1; // always use Bus
                if (chkBoat4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkUBahn4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkTram4.Checked) _Transfers4 += 1; else _Transfers4 += 0;
                if (chkTaxi4.Checked) _Transfers4 += 1; else _Transfers4 += 0;

                _Transfers4 += "000000";

                _Transfers4Registry = "";

                if (chkICE4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkECIC4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkIR4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkIRE4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkRE4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkRB4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkSBahn4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkBus4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkBoat4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkUBahn4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkTram4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;
                if (chkTaxi4.Checked) _Transfers4Registry += 1; else _Transfers4Registry += 0;


        }

        private bool Connected()
        {
            bool ret;
            try
            {
                string HostName = Dns.GetHostName();
                IPHostEntry thisHost = Dns.GetHostEntry(HostName);
                string thisIpAddr = thisHost.AddressList[0].ToString();
                ret = thisIpAddr != IPAddress.Parse("127.0.0.1").ToString();
            }
            catch
            {
                return false;
            }
            return ret;
        }

        private string ClearText(string input)
        {
            input = input.Replace("\n", "");
            input = input.Replace("\r", "");

            input = input.Replace("&nbsp;", " ");		//no-breakspace=non-breakingspace
            input = input.Replace("&iexcl;", "");		//invertedexclamationmark
            input = input.Replace("&cent;", "");		//centsign
            input = input.Replace("&pound;", "");		//poundsign
            input = input.Replace("&curren;", "");		//currencysign
            input = input.Replace("&yen;", "");		//yensign=yuansign
            input = input.Replace("&brvbar;", "");		//brokenbar=brokenverticalbar
            input = input.Replace("&sect;", "");		//sectionsign
            input = input.Replace("&uml;", "");		//diaeresis=spacingdiaeresis(Umlaut)
            input = input.Replace("&copy;", "");		//copyrightsign
            input = input.Replace("&ordf;", "");		//feminineordinalindicator
            input = input.Replace("&laquo;", "");		//left-pointingdoubleanglequotationmark
            input = input.Replace("&not;", "");		//notsign
            input = input.Replace("&shy;", "");		//softhyphen=discretionaryhyphen
            input = input.Replace("&reg;", "");		//registeredsign=registeredtrademarksig
            input = input.Replace("&macr;", "");		//macron=spacingmacron=overline=APLov
            input = input.Replace("&deg;", "");		//degreesign
            input = input.Replace("&plusmn;", "");		//plus-minussign=plus-or-minussign
            input = input.Replace("&sup2;", "");		//superscripttwo=superscriptdigittwo
            input = input.Replace("&sup3;", "");		//superscriptthree=superscriptdigitthree
            input = input.Replace("&acute;", "");		//acuteaccent=spacingacute
            input = input.Replace("&micro;", "");		//microsign
            input = input.Replace("&para;", "");		//pilcrowsign=paragraphsign
            input = input.Replace("&middot;", "");		//middledot=Georgiancomma=Greekmiddle
            input = input.Replace("&cedil;", "");		//cedilla=spacingcedilla
            input = input.Replace("&sup1;", "");		//superscriptone=superscriptdigitone
            input = input.Replace("&ordm;", "");		//masculineordinalindicator
            input = input.Replace("&raquo;", "");		//right-pointingdoubleanglequotationmark
            input = input.Replace("&frac14;", "");		//vulgarfractiononequarter
            input = input.Replace("&frac12;", "");		//vulgarfractiononehalf
            input = input.Replace("&frac34;", "");		//vulgarfractionthreequarters
            input = input.Replace("&iquest;", "");		//invertedquestionmark
            input = input.Replace("&Agrave;", "");		//latincapitalletterAwithgrave
            input = input.Replace("&Aacute;", "");		//latincapitalletterAwithacute
            input = input.Replace("&Acirc;", "");		//latincapitalletterAwithcircumflex
            input = input.Replace("&Atilde;", "");		//latincapitalletterAwithtilde
            input = input.Replace("&Auml;", "");		//latincapitalletterAwithdiaeresis
            input = input.Replace("&Aring;", "");		//latincapitalletterAwithringabove
            input = input.Replace("&AElig;", "");		//latincapitalletterAE
            input = input.Replace("&Ccedil;", "");		//latincapitalletterCwithcedilla
            input = input.Replace("&Egrave;", "");		//latincapitalletterEwithgrave
            input = input.Replace("&Eacute;", "");		//latincapitalletterEwithacute
            input = input.Replace("&Ecirc;", "");		//latincapitalletterEwithcircumflex
            input = input.Replace("&Euml;", "");		//latincapitalletterEwithdiaeresis
            input = input.Replace("&Igrave;", "");		//latincapitalletterIwithgrave
            input = input.Replace("&Iacute;", "");		//latincapitalletterIwithacute
            input = input.Replace("&Icirc;", "");		//latincapitalletterIwithcircumflex
            input = input.Replace("&Iuml;", "");		//latincapitalletterIwithdiaeresis
            input = input.Replace("&ETH;", "");		//latincapitalletterETH
            input = input.Replace("&Ntilde;", "");		//latincapitalletterNwithtilde
            input = input.Replace("&Ograve;", "");		//latincapitalletterOwithgrave
            input = input.Replace("&Oacute;", "");		//latincapitalletterOwithacute
            input = input.Replace("&Ocirc;", "");		//latincapitalletterOwithcircumflex
            input = input.Replace("&Otilde;", "");		//latincapitalletterOwithtilde
            input = input.Replace("&Ouml;", "");		//latincapitalletterOwithdiaeresis
            input = input.Replace("&times;", "");		//multiplicationsign
            input = input.Replace("&Oslash;", "");		//latincapitalletterOwithstroke
            input = input.Replace("&Ugrave;", "");		//latincapitalletterUwithgrave
            input = input.Replace("&Uacute;", "");		//latincapitalletterUwithacute
            input = input.Replace("&Ucirc;", "");		//latincapitalletterUwithcircumflex
            input = input.Replace("&Uuml;", "");		//latincapitalletterUwithdiaeresis
            input = input.Replace("&Yacute;", "");		//latincapitalletterYwithacute
            input = input.Replace("&THORN;", "");		//latincapitalletterTHORN
            input = input.Replace("&szlig;", "");		//latinsmalllettersharps=ess-zed
            input = input.Replace("&agrave;", "");		//latinsmallletterawithgrave
            input = input.Replace("&aacute;", "");		//latinsmallletterawithacute
            input = input.Replace("&acirc;", "");		//latinsmallletterawithcircumflex
            input = input.Replace("&atilde;", "");		//latinsmallletterawithtilde
            input = input.Replace("&auml;", "");		//latinsmallletterawithdiaeresis
            input = input.Replace("&aring;", "");		//latinsmallletterawithringabove
            input = input.Replace("&aelig;", "");		//latinsmallletterae
            input = input.Replace("&ccedil;", "");		//latinsmalllettercwithcedilla
            input = input.Replace("&egrave;", "");		//latinsmallletterewithgrave
            input = input.Replace("&eacute;", "");		//latinsmallletterewithacute
            input = input.Replace("&ecirc;", "");		//latinsmallletterewithcircumflex
            input = input.Replace("&euml;", "");		//latinsmallletterewithdiaeresis
            input = input.Replace("&igrave;", "");		//latinsmallletteriwithgrave
            input = input.Replace("&iacute;", "");		//latinsmallletteriwithacute
            input = input.Replace("&icirc;", "");		//latinsmallletteriwithcircumflex
            input = input.Replace("&iuml;", "");		//latinsmallletteriwithdiaeresis
            input = input.Replace("&eth;", "");		//latinsmalllettereth
            input = input.Replace("&ntilde;", "");		//latinsmallletternwithtilde
            input = input.Replace("&ograve;", "");		//latinsmallletterowithgrave
            input = input.Replace("&oacute;", "");		//latinsmallletterowithacute
            input = input.Replace("&ocirc;", "");		//latinsmallletterowithcircumflex
            input = input.Replace("&otilde;", "");		//latinsmallletterowithtilde
            input = input.Replace("&ouml;", "");		//latinsmallletterowithdiaeresis
            input = input.Replace("&divide;", "");		//divisionsign
            input = input.Replace("&oslash;", "");		//latinsmallletterowithstroke
            input = input.Replace("&ugrave;", "");		//latinsmallletteruwithgrave
            input = input.Replace("&uacute;", "");		//latinsmallletteruwithacute
            input = input.Replace("&ucirc;", "");		//latinsmallletteruwithcircumflex
            input = input.Replace("&uuml;", "");		//latinsmallletteruwithdiaeresis
            input = input.Replace("&yacute;", "");		//latinsmallletterywithacute
            input = input.Replace("&thorn;", "");		//latinsmallletterthorn
            input = input.Replace("&yuml;", "");		//latinsmallletterywithdiaeresis
            input = input.Replace("&#160;", " ");		//no-breakspace=non-breakingspace
            input = input.Replace("&#161;", "");		//invertedexclamationmark
            input = input.Replace("&#162;", "");		//centsign
            input = input.Replace("&#163;", "");		//poundsign
            input = input.Replace("&#164;", "");		//currencysign
            input = input.Replace("&#165;", "");		//yensign=yuansign
            input = input.Replace("&#166;", "");		//brokenbar=brokenverticalbar
            input = input.Replace("&#167;", "");		//sectionsign
            input = input.Replace("&#168;", "");		//diaeresis=spacingdiaeresis(Umlaut)
            input = input.Replace("&#169;", "");		//copyrightsign
            input = input.Replace("&#170;", "");		//feminineordinalindicator
            input = input.Replace("&#171;", "");		//left-pointingdoubleanglequotationmark
            input = input.Replace("&#172;", "");		//notsign
            input = input.Replace("&#173;", "");		//softhyphen=discretionaryhyphen
            input = input.Replace("&#174;", "");		//registeredsign=registeredtrademarksig
            input = input.Replace("&#175;", "");		//macron=spacingmacron=overline=APLov
            input = input.Replace("&#176;", "");		//degreesign
            input = input.Replace("&#177;", "");		//plus-minussign=plus-or-minussign
            input = input.Replace("&#178;", "");		//superscripttwo=superscriptdigittwo
            input = input.Replace("&#179;", "");		//superscriptthree=superscriptdigitthree
            input = input.Replace("&#180;", "");		//acuteaccent=spacingacute
            input = input.Replace("&#181;", "");		//microsign
            input = input.Replace("&#182;", "");		//pilcrowsign=paragraphsign
            input = input.Replace("&#183;", "");		//middledot=Georgiancomma=Greekmiddle
            input = input.Replace("&#184;", "");		//cedilla=spacingcedilla
            input = input.Replace("&#185;", "");		//superscriptone=superscriptdigitone
            input = input.Replace("&#186;", "");		//masculineordinalindicator
            input = input.Replace("&#187;", "");		//right-pointingdoubleanglequotationmark
            input = input.Replace("&#188;", "");		//vulgarfractiononequarter
            input = input.Replace("&#189;", "");		//vulgarfractiononehalf
            input = input.Replace("&#190;", "");		//vulgarfractionthreequarters
            input = input.Replace("&#191;", "");		//invertedquestionmark
            input = input.Replace("&#192;", "");		//latincapitalletterAwithgrave
            input = input.Replace("&#193;", "");		//latincapitalletterAwithacute
            input = input.Replace("&#194;", "");		//latincapitalletterAwithcircumflex
            input = input.Replace("&#195;", "");		//latincapitalletterAwithtilde
            input = input.Replace("&#196;", "");		//latincapitalletterAwithdiaeresis
            input = input.Replace("&#197;", "");		//latincapitalletterAwithringabove
            input = input.Replace("&#198;", "");		//latincapitalletterAE
            input = input.Replace("&#199;", "");		//latincapitalletterCwithcedilla
            input = input.Replace("&#200;", "");		//latincapitalletterEwithgrave
            input = input.Replace("&#201;", "");		//latincapitalletterEwithacute
            input = input.Replace("&#202;", "");		//latincapitalletterEwithcircumflex
            input = input.Replace("&#203;", "");		//latincapitalletterEwithdiaeresis
            input = input.Replace("&#204;", "");		//latincapitalletterIwithgrave
            input = input.Replace("&#205;", "");		//latincapitalletterIwithacute
            input = input.Replace("&#206;", "");		//latincapitalletterIwithcircumflex
            input = input.Replace("&#207;", "");		//latincapitalletterIwithdiaeresis
            input = input.Replace("&#208;", "");		//latincapitalletterETH
            input = input.Replace("&#209;", "");		//latincapitalletterNwithtilde
            input = input.Replace("&#210;", "");		//latincapitalletterOwithgrave
            input = input.Replace("&#211;", "");		//latincapitalletterOwithacute
            input = input.Replace("&#212;", "");		//latincapitalletterOwithcircumflex
            input = input.Replace("&#213;", "");		//latincapitalletterOwithtilde
            input = input.Replace("&#214;", "");		//latincapitalletterOwithdiaeresis
            input = input.Replace("&#215;", "");		//multiplicationsign
            input = input.Replace("&#216;", "");		//latincapitalletterOwithstroke
            input = input.Replace("&#217;", "");		//latincapitalletterUwithgrave
            input = input.Replace("&#218;", "");		//latincapitalletterUwithacute
            input = input.Replace("&#219;", "");		//latincapitalletterUwithcircumflex
            input = input.Replace("&#220;", "");		//latincapitalletterUwithdiaeresis
            input = input.Replace("&#221;", "");		//latincapitalletterYwithacute
            input = input.Replace("&#222;", "");		//latincapitalletterTHORN
            input = input.Replace("&#223;", "");		//latinsmalllettersharps=ess-zed
            input = input.Replace("&#224;", "");		//latinsmallletterawithgrave
            input = input.Replace("&#225;", "");		//latinsmallletterawithacute
            input = input.Replace("&#226;", "");		//latinsmallletterawithcircumflex
            input = input.Replace("&#227;", "");		//latinsmallletterawithtilde
            input = input.Replace("&#228;", "");		//latinsmallletterawithdiaeresis
            input = input.Replace("&#229;", "");		//latinsmallletterawithringabove
            input = input.Replace("&#230;", "");		//latinsmallletterae
            input = input.Replace("&#231;", "");		//latinsmalllettercwithcedilla
            input = input.Replace("&#232;", "");		//latinsmallletterewithgrave
            input = input.Replace("&#233;", "");		//latinsmallletterewithacute
            input = input.Replace("&#234;", "");		//latinsmallletterewithcircumflex
            input = input.Replace("&#235;", "");		//latinsmallletterewithdiaeresis
            input = input.Replace("&#236;", "");		//latinsmallletteriwithgrave
            input = input.Replace("&#237;", "");		//latinsmallletteriwithacute
            input = input.Replace("&#238;", "");		//latinsmallletteriwithcircumflex
            input = input.Replace("&#239;", "");		//latinsmallletteriwithdiaeresis
            input = input.Replace("&#240;", "");		//latinsmalllettereth
            input = input.Replace("&#241;", "");		//latinsmallletternwithtilde
            input = input.Replace("&#242;", "");		//latinsmallletterowithgrave
            input = input.Replace("&#243;", "");		//latinsmallletterowithacute
            input = input.Replace("&#244;", "");		//latinsmallletterowithcircumflex
            input = input.Replace("&#245;", "");		//latinsmallletterowithtilde
            input = input.Replace("&#246;", "");		//latinsmallletterowithdiaeresis
            input = input.Replace("&#247;", "");		//divisionsign
            input = input.Replace("&#248;", "");		//latinsmallletterowithstroke
            input = input.Replace("&#249;", "");		//latinsmallletteruwithgrave
            input = input.Replace("&#250;", "");		//latinsmallletteruwithacute
            input = input.Replace("&#251;", "");		//latinsmallletteruwithcircumflex
            input = input.Replace("&#252;", "");		//latinsmallletteruwithdiaeresis
            input = input.Replace("&#253;", "");		//latinsmallletterywithacute
            input = input.Replace("&#254;", "");		//latinsmallletterthorn
            input = input.Replace("&#255;", "");		//latinsmallletterywithdiaeresis


            return input;
        }

        private void inputPanel_EnabledChanged(object sender, EventArgs e)
        {
            if (this.inputPanel.Enabled)
            {
                this.tbcSettingsMain.Height -= this.inputPanel.Bounds.Height;
            }
            else
            {
                this.tbcSettingsMain.Height = this.ClientSize.Height;
            }
        }

     }
}
